/* cstring.h
 *
 * $Id$
 *
 * Copyright 1990, 1991, 1992, 1993, 1994, 1995, Oliver Laumann, Berlin
 * Copyright 2002, 2003 Sam Hocevar <sam@hocevar.net>, Paris
 *
 * This software was derived from Elk 1.2, which was Copyright 1987, 1988,
 * 1989, Nixdorf Computer AG and TELES GmbH, Berlin (Elk 1.2 has been written
 * by Oliver Laumann for TELES Telematic Services, Berlin, in a joint project
 * between TELES and Nixdorf Microprocessor Engineering, Berlin).
 *
 * Oliver Laumann, TELES GmbH, Nixdorf Computer AG and Sam Hocevar, as co-
 * owners or individual owners of copyright in this software, grant to any
 * person or company a worldwide, royalty free, license to
 *
 *    i) copy this software,
 *   ii) prepare derivative works based on this software,
 *  iii) distribute copies of this software or derivative works,
 *   iv) perform this software, or
 *    v) display this software,
 *
 * provided that this notice is not removed and that neither Oliver Laumann
 * nor Teles nor Nixdorf are deemed to have made any representations as to
 * the suitability of this software for any purpose nor are held responsible
 * for any defects of this software.
 *
 * THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 */

/* These must be defined as macros, because they use Alloca().
 */

#define Get_String_Stack(_from,_to) {\
    unsigned int _len;\
    Check_Type(_from, T_String);\
    _len = STRING(_from)->size;\
    Alloca ((_to), char*, _len+1);\
    memcpy ((_to), STRING(_from)->data, _len);\
    (_to)[_len] = '\0';\
}

#define Get_Strsym_Stack(_from,_to) {\
    unsigned int _len;\
    if (TYPE(_from) == T_Symbol)\
        (_from) = SYMBOL(_from)->name;\
    else if (TYPE(_from) != T_String)\
        Wrong_Type_Combination ((_from), "string or symbol");\
    _len = STRING(_from)->size;\
    Alloca ((_to), char*, _len+1);\
    memcpy ((_to), STRING(_from)->data, _len);\
    (_to)[_len] = '\0';\
}
